/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "CrystalCPUID.h"
#include "CrystalCPUIDDlg.h"

#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCrystalCPUIDApp

BEGIN_MESSAGE_MAP(CCrystalCPUIDApp, CWinApp)
	//{{AFX_MSG_MAP(CCrystalCPUIDApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCrystalCPUIDApp 

CCrystalCPUIDApp::CCrystalCPUIDApp()
{
}

/////////////////////////////////////////////////////////////////////////////

CCrystalCPUIDApp theApp;

int gLanguage = JAPANESE;
CBitmap gBackBitmap;
CBrush gBackBrush;
COLORREF gTextColor;
BOOL gFlagBack = FALSE;

int gDialogID = IDD_CRYSTALCPUID_DIALOG; // Default Dialog Templete

/////////////////////////////////////////////////////////////////////////////

BOOL CCrystalCPUIDApp::InitInstance()
{
	HANDLE hMutex = ::CreateMutex(NULL,FALSE,"CrystalCPUID");
	if (GetLastError()==ERROR_ALREADY_EXISTS){return FALSE;}
	
	// Set INI file place... 
	char aINIFile[MAX_PATH];
	char* ptrEnd;
	::GetModuleFileName(NULL, aINIFile, MAX_PATH);
	if ( (ptrEnd = strrchr(aINIFile, '.')) != NULL ) {
		*ptrEnd = '\0';
		strcat(aINIFile, ".ini");
		free((void*)m_pszProfileName);
		m_pszProfileName = strdup(aINIFile);
	}

	char str[256];
	GetPrivateProfileString("Setting","Dialog","",str,256,m_pszProfileName);
	if( ! strcmp(str,"24") ){
		gDialogID = IDD_CRYSTALCPUID_DIALOG_24;
	}else if( ! strcmp(str,"POP") ){
		gDialogID = IDD_CRYSTALCPUID_DIALOG_POP;
	}


	// Select Dialog Templete
	for(int i=0; i<__argc; i++)
    {
		if( ! _stricmp(__argv[i],"-D24") || ! _stricmp(__argv[i],"/D24") ){
			gDialogID = IDD_CRYSTALCPUID_DIALOG_24;
		}
		if( ! _stricmp(__argv[i],"-DPOP") || ! _stricmp(__argv[i],"/DPOP") ){
			gDialogID = IDD_CRYSTALCPUID_DIALOG_POP;
		}
    }

	// Multimedia Timer Setting
	TIMECAPS tc;
	timeGetDevCaps(&tc,sizeof(TIMECAPS));
	timeBeginPeriod(tc.wPeriodMin);

	CCrystalCPUIDDlg dlg;
	m_pMainWnd = &dlg;
	dlg.DoModal();

	timeEndPeriod(tc.wPeriodMin);

	::ReleaseMutex(hMutex);
	::CloseHandle(hMutex);
	
	return FALSE;
}
